Gamestate.game = Gamestate.new()
local state = Gamestate.game


function state:update(dt)
	world:update(dt)

	-- Update sprite's coordinates
	local sprite = map.layers["Sprite Layer"].sprite
	local down = love.keyboard.isDown

	local x, y = 0, 0
	if down("w") or down("up")		then y = y - 4000 end
	if down("s") or down("down")	then y = y + 4000 end
	if down("a") or down("left")	then x = x - 4000 end
	if down("d") or down("right")	then x = x + 4000 end
	sprite.body:applyForce(x, y)
	sprite.x, sprite.y = sprite.body:getWorldCenter()

	map:update(dt)
end

function state:draw()
	--cam:attach()
	--draw_world()
	--cam:detach()
	love.graphics.print("game", 300, 300)
	
	local sprite = map.layers["Sprite Layer"].sprite
	local ww = love.graphics.getWidth()
	local wh = love.graphics.getHeight()
	local tx = math.floor(-sprite.x + ww / 2 - 16)
	local ty = math.floor(-sprite.y + wh / 2 - 16)

	-- Draw sprite in centre of screen
	love.graphics.push()
	love.graphics.translate(tx, ty)
	map:setDrawRange(tx, ty, ww, wh)
	map:draw()

	love.graphics.setColor(255, 255, 0, 255)
	map:drawWorldCollision(collision)

	love.graphics.setColor(255, 0, 0, 255)
	love.graphics.polygon("line", sprite.body:getWorldPoints(sprite.shape:getPoints()))
	love.graphics.pop()

	local dir = "WASD / UDLR to move"
	love.graphics.setColor(255, 0, 0, 255)
	love.graphics.print(dir, 30, 30)
	love.graphics.setColor(255, 255, 255, 255)
	
end

function state:focus(f)
  if not f then
    Gamestate.switch(Gamestate.pause)
  end
end

--function draw_world()
	--map:draw(1,1)
	--love.graphics.setColor(255,255,255,255)
	--map:drawImageLayer("BG0")
	--map:drawImageLayer("BG1")
	--map:drawImageLayer("BG2")
	--map:drawTileLayer("Ground")
	--map:drawTileLayer("Ground overlay")
	--ide majd jön a sprite layer
	--love.graphics.draw(player.bg, player.x, player.y)
	--map:drawTileLayer("Overlay")
	--map:drawTileLayer("Top overlay")*/
--end

function love.resize(w, h)
	map:resize(w, h)
end